<?php

defined('_JEXEC') or die('Restricted access');

class plgJshoppingcheckoutCheck_tax_for_eu extends JPlugin {
	
	private $errorMsg = '';

    function __construct(&$subject, $config) {
        parent::__construct($subject, $config);
    }

    public function onBeforeSaveCheckoutStep2(&$adv_user) {
		$app = \JFactory::getApplication();
        $taxNumber = strval($adv_user->tax_number);
		$taxNumber = trim($taxNumber);
		
		\JSHelper::saveToLog("check_tax_for_eu.log", 'step2: '.$taxNumber);
		
        if ($taxNumber == '') {
            return NULL;
        }
		
		if (!$this->checkTaxNumber($taxNumber)){
			$url = \JSHelper::SEFLink('index.php?option=com_jshopping&controller=checkout&task=step2', 0, 1);			
			$app->enqueueMessage($this->errorMsg, 'error');
			$app->redirect($url);
		}
    }
		
	public function onBeforeCheckJshopUserShop(&$model, &$type, &$config_fields, &$type2, &$return){
		if ($type == 'register' && $this->params->get('check_registration', 0)) {			
			$taxNumber = strval($model->tax_number);
			$taxNumber = trim($taxNumber);
			\JSHelper::saveToLog("check_tax_for_eu.log", 'register: '.$taxNumber);
			
			if ($taxNumber==''){
				return;
			}			
			
			if (!$this->checkTaxNumber($taxNumber)){
				$model->_error = $this->errorMsg;
				$return = false;
			}
		}
	}
	
	function  checkTaxNumber($tax_number){
		$lang = \JFactory::getLanguage();
        $lang->load('plg_jshoppingcheckout_check_tax_for_eu', JPATH_ADMINISTRATOR);
		$check = 0;
        $vatid = strval($tax_number);
        $vatid = str_replace(array(' ', '.', '-', ',', ', '), '', trim($vatid));
        $cc = substr($vatid, 0, 2);
        $vn = substr($vatid, 2);
        
		ini_set('default_socket_timeout', 5);
        $client = new SoapClient("http://ec.europa.eu/taxation_customs/vies/checkVatService.wsdl");
        
        if ($client) {
            $params = array('countryCode' => $cc, 'vatNumber' => $vn);
            try {
                $r = $client->checkVat($params);

                if ($r->valid == true) {
                    $check = 1;
                } else {
					$check = 0;
                    $this->errorMsg = \JText::_('WRONG_FORMAT');
                }
            } catch (SoapFault $e) {
				$check = 0;
                $this->errorMsg = 'Error: '.\JText::_(str_replace(' ', '_', $e->faultstring));
            }
        } else {
			$check = 0;
            $this->errorMsg = 'Connection to host not possible, europe.eu';
        }
		\JSHelper::saveToLog("check_tax_for_eu.log", 'check: '.$check." ".$this->errorMsg);
		
		return $check;
	}

}